// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', [
  'ionic', 
  'starter.consts', 
  'starter.services', 
  'starter.controllers', 
  'starter.directives',
  'validation.engine'
])

.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if(window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if(window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
  });
})

.config(function($stateProvider, $urlRouterProvider) {
  $stateProvider

    .state('app', {
      url: '/app',
      abstract: true,
      templateUrl: 'views/menu.html',
      controller: 'AppController'
    })

    .state('app.marks', {
      url: '/marks',
      views: {
        'menuContent' :{
          templateUrl: 'views/marks.html',
          controller: 'MarksController'
        }
      }
    })

    .state('app.tags', {
      url: '/tags',
      views: {
        'menuContent' :{
          templateUrl: 'views/tags.html',
          controller: 'TagsController'
        }
      }
    })

    .state('app.single', {
      url: '/tag/:tagName/:tagId',
      views: {
        'menuContent' :{
          templateUrl: 'views/marks.html',
          controller: 'MarksController'
        }
      }
    })

    .state('app.history', {
      url: '/history',
      views: {
        'menuContent' :{
          templateUrl: 'views/history.html',
          controller: 'HistoryController'
        }
      }
    })

    .state('app.settings', {
      url: '/settings',
      views: {
        'menuContent' :{
          templateUrl: 'views/settings.html',
          controller: 'SettingsController'
        }
      }
    });

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/marks');
});

