angular.module('starter.directives', [])

.directive('loader', function($rootScope) {
	return {
		templateUrl: 'views/loader.html',
		link: function(scope, element, attr) {}
	};
})

.directive('loginForm', function($rootScope, UserService) {
    return {
        link: function(scope, element, attr) {
            element.submit(function(e) {
                e.preventDefault()
                var email = scope.loginData.email;
                var password = scope.loginData.password;
                                
                if(scope.formSubmitted || !email || !password || element.find('.error').length >= 1) { 
                    return; 
                }

                element.find('.error').remove();
                scope.formSubmitted = true;

                if(!scope.$$phase) {
                    scope.$apply();
                }

                UserService.login(email, password).then(function(res) {
                    if(res.data.success) {
                        UserService.getUserInfoRequest();
                        scope.closeAuth();
                    }
                    else {
                        element.find('input[name=password]').parent().append('<div class="error">' + res.data.message + '</div>');
                    }
                    scope.formSubmitted = false;

                    if(!scope.$$phase) {
                        scope.$apply();
                    }
                });
            });
        }
    };
})

.directive('signupForm', function($rootScope, UserService) {
    return {
        link: function(scope, element, attr) {
            element.submit(function(e) {
                e.preventDefault()
                var name = scope.loginData.regName;
                var email = scope.loginData.regEmail;
                var password = scope.loginData.regPassword;

                if(!email || !password || !name || element.find('.error').length >= 1 || scope.formSubmitted) { return; }
                element.find('.error').remove();
                scope.formSubmitted = true;

                UserService.signup(email, name, password).then(function(res) {
                    if(res.data.success) {
                        UserService.getUserInfoRequest();
                        scope.closeAuth();
                    }
                    else {
                        element.find('input[name=email]').parent().append('<div class="error">' + res.data.message + '</div>');
                    }
                    scope.formSubmitted = false;
                });
            });
        }
    };
})

.directive('share', function($rootScope) {
	return {
		scope: {
            doc: '=doc'
        },
        link: function(scope, element, attr) {
            element.on('click', function(e) {
                if(window.plugins && window.plugins.socialsharing) {
                    window.plugins.socialsharing.share(scope.doc.title + '. Shared with #Markticle', null, null, scope.doc.url);
                }
    	   });
        }
	};
})

.directive('docUrl', function($rootScope, SettingsService) {
	return {
		link: function(scope, element, attr) {
        	element.on('click', 'a', function(e) {
        		e.preventDefault();
        		var ref = window.open(element.attr('href'), '_blank', 'location=yes');
                var settings = SettingsService.get();
                var markticlePosition = element.data('elmtype') + ':' + element.data('text');

                ref.addEventListener('loadstop', function() {
                    // Getting Markticle's code and inject to page.
                    $.get('js/markticle.js', function(data) {
                        var code = data.replace('markticleOptions = {}', "markticleOptions = {markerBackground: '" + settings.markerBackground + "', markerColor: '" + settings.markerColor + "', autoScroll: " + settings.autoScroll + "}");
                        code = code.replace('markticlePosition = null', 'markticlePosition = ' + "'" + markticlePosition + "'");
                        ref.executeScript({
                            code: code
                        }, function() {　
                            console.log('Markticle injected!');
                        });
                    });
                });
        	});
        }
	};
});