(function(){

	var markticleOnPage = function(options, positionText, contentElm) {
		this.options = options;
		this.positionText = positionText;
		this.contentElm = contentElm;
		this.init();
	};

	markticleOnPage.constructor = markticleOnPage;

	markticleOnPage.prototype = {
		init: function() {
			var me = this;
			
			// Initialized the default settings
			me.options = jQuery.extend({}, me.defaults, me.options);

			// Attach events
			// me.attachEvents();

			// Scroll to marked text
			me.scrollToText();
		},

		attachEvents: function() {
			var selectionEndTimeout = null;

			document.removeEventListener('selectionchange', userSelectionChanged);
			document.addEventListener('selectionchange', userSelectionChanged);

			function userSelectionChanged() {
			    if (selectionEndTimeout) {
			        clearTimeout(selectionEndTimeout);
			    }

			    selectionEndTimeout = setTimeout(function () {
			        jQuery(window).trigger('selectionEnd');
			    }, 500);
			}

			jQuery(window).unbind('selectionEnd').bind('selectionEnd', function () {
			    selectionEndTimeout = null;


			    alert('now selection end');
			});
		},

		scrollToText: function(contentElm) {
			var me = this;
			if(me.positionText) {
				var split = me.positionText.split(':');
				var elmType = split[0];
				var text = me.positionText.replace(elmType + ':', '');

				console.log('finding element to scroll');

				me.highlightElement({
					text: text.replace(/%20/g, ' '),
					elmType: elmType
				}, null, true);
			}
		},

		highlightElement: function(obj, elm, scroll) {
			var me = this;
			text = obj.text;
			if(!elm) {
				elm = jQuery(obj.elmType + ':contains("' + text + '")');
			}

			if(elm) {
				console.log('element exists');

				var fontSize = elm.css('fontSize');
				var highlighterStyles = 'background: #' + me.options.markerBackground + '; color: #' + me.options.markerColor + '; cursor: pointer; display: inline; padding: 0; margin: 0; font-size: ' + fontSize;

				elm.html(function(_, html) {
				   return html.replace(text, '<span class="markticle_highlighter" title="Double click to remove" style="' + highlighterStyles + '">' + text + '</span>');
				});

				var highlighterElm = elm.find('.markticle_highlighter');
				if(highlighterElm.length) {
					if(scroll && (me.options.autoScroll == true || me.options.autoScroll === 'true' || typeof me.options.autoScroll === 'undefined')) {
						console.log('scrolling to element');
						jQuery('body').animate({
							scrollTop: highlighterElm.offset().top - 10 + 'px'
						});
					}
					else if(!scroll) {
						me.highlightText(highlighterElm);
					}
				}
			}
			else {
				console.log('Cannot find element');
			}
		},

		highlightText: function(highlighterElm) {
			var el = highlighterElm[0];
			if (document.selection) {
		        document.selection.empty();
		        var range = document.body.createTextRange();
		        range.moveToElementText(el);
		        range.select();
		    }
		    else if (window.getSelection) {
		        window.getSelection().removeAllRanges();
		        var range = document.createRange();
		        range.selectNode(el);
		        window.getSelection().addRange(range);
		    }
		},

		defaults: {
			markerBackground: 'ffd84b',
			markerColor: '#333',
			autoScroll: 'true',
			blockedDomains: []
		}
	};

	var startMarkticle = function() {
		console.log('Starting Markticle');
		jQuery(document).ready(function() {
			console.log('Doc ready');
			var markticleOptions = {};
			var markticlePosition = null;
			var markticle = new markticleOnPage(markticleOptions, markticlePosition, jQuery('body'));
		});
	};

	var checkIfjQueryExist = function() {
		if (typeof jQuery == 'undefined') {
		    var script = document.createElement('script');
		    script.type = 'text/javascript';
		    script.src = 'http://ajax.googleapis.com/ajax/libs/jquery/2.0.3/jquery.min.js';
		    script.onload = script.onreadystatechange = function() {
		    	startMarkticle();
		    };
		    document.getElementsByTagName('head')[0].appendChild(script);
		}
		else {
			startMarkticle();
		}
	};

	checkIfjQueryExist();

})();